# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support
%bcond_without maven

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/apache/neethi/%{short_name}/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section     free
%define short_name  neethi

Name:           ws-commons-neethi
Version:        2.0.4
Release:        1.2.2.3%{?dist}
Epoch:          0
Summary:        Apache Neethi WS-Policy implementation 
License:        ASL 2.0
Group:          Text Processing/Markup/XML
URL:            http://ws.apache.org/commons/neethi/index.html
# svn -q export http://svn.apache.org/repos/asf/webservices/commons/tags/neethi/2.0.4/ neethi && tar cjf neethi-2.0.4.tar.bz2 neethi
Source0:        %{short_name}-%{version}.tar.bz2
Source1:        %{name}-setting.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-build.xml
Source4:	%{name}-component-info.xml
Source5:	ws-commons-neethi-upload.sh
Requires(post):    jpackage-utils >= 0:1.7.3
Requires(postun):  jpackage-utils >= 0:1.7.3
BuildRequires:  ant >= 0:1.6
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jdepend
BuildRequires:  junit >= 0:3.8.2
BuildRequires:  maven-deploy-plugin

%if %with maven
BuildRequires:  maven2 >= 2.0.7
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-one
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven2-default-skin
BuildRequires:  maven-jxr
BuildRequires:  maven-release-plugin
BuildRequires:  maven-surefire-provider-junit
#BuildRequires:  mojo-maven2-plugin-jdepend
%endif
%if %{gcj_support}
BuildRequires:    java-gcj-compat-devel
Requires(post):   java-gcj-compat
Requires(postun): java-gcj-compat
%endif
BuildRequires:  ws-commons-axiom >= 0:1.2.3
#BuildRequires:  wstx32
BuildRequires:  wstx
BuildRequires:  stax_1_0_api
BuildRequires:  codehaus-stax11-api

BuildRequires:  jakarta-commons-logging
#Use wsdl4j16 instead of wsdl4j on RHEL 5
BuildRequires:  wsdl4j16 >= 0:1.6.2

Requires:       jpackage-utils >= 0:1.7.3
Requires:       java >= 0:1.5.0
Requires:       ws-commons-axiom >= 0:1.2.3
#Requires:       wstx32
Requires:	wstx
Requires:       stax_1_0_api
Requires:       jakarta-commons-logging
#Use wsdl4j16 instead of wsdl4j on RHEL 5
Requires:       wsdl4j16 >= 0:1.6.2

# ws-commons-policy has NOT been renamed to neethi
Provides:   neethi = %{epoch}:%{version}-%{release}
Obsoletes:  neethi <= 0:1.0.1
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Apache Neethi provides an implementation of WS-Policy specification.It
provides a convenient model to process any policy information at
runtime. In other words, it allows you to convert any policy to an
object (which is its runtime representation) and play with it as you
like.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{short_name}
cp -p %{SOURCE1} settings.xml
cp -p %{SOURCE3} build.xml
find . -name "*.jar" -exec rm -f {} \;

%build
%if %with maven
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

mvn-jpp \
        -e \
        -s $(pwd)/settings.xml \
        -Dmaven2.jpp.mode=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        install javadoc:javadoc 
%else
export OPT_JAR_LIST=
export CLASSPATH=$(build-classpath \
stax_1_0_api \
ws-commons-axiom-api \
ws-commons-axiom-impl \
wstx/wstx-asl \
)
CLASSPATH=$CLASSPATH:target/classes:target/test-classes
%{ant} -Dbuild.sysclasspath=only jar test javadoc
%endif

%install
rm -rf $RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -p -m 644 target/%{short_name}-%{version}.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap org.apache.neethi neethi %{version} JPP %{name}
install -p -m 644 target/%{short_name}-%{version}-sources.jar \
           $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar

# create unprefixed and unversioned symlinks
(cd $RPM_BUILD_ROOT%{_javadir}
for jar in *-%{version}*; do ln -sf ${jar} ${jar/-%{version}/}; done
ln -s %{name}.jar %{short_name}.jar
)

# poms
%if %with maven
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 pom.xml \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}.pom
%endif

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p *.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
%if %with maven
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
rm -rf $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/apidocs
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%if %with repolib
%{__install} -d -m 755 %{buildroot}%{repodir}
%{__install} -d -m 755 %{buildroot}%{repodirlib}
%{__install} -p -m 644 %{SOURCE4} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml

%{__install} -d -m 755 %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE3} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/%{short_name}.jar
%{__cp} -p pom.xml %{buildroot}%{repodirlib}/%{short_name}.pom
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{version}-sources.jar %{buildroot}%{repodirlib}/%{short_name}-sources.jar
%{__install} -p -m 755 %{SOURCE5} %{buildroot}%{repodir}/upload.sh
pushd %{buildroot}%{repodir}
./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
popd
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap 
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_docdir}/%{name}-%{version}
%doc %{_docdir}/%{name}-%{version}/*
%{_javadir}*/*.jar
%{_datadir}/maven2/poms/JPP.%{name}.pom
%{_mavendepmapfragdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-*%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Apr 06 2011 Martha Benitez <mbenitez@redhat.com> - 0:2.0.4-1.2.2.3
- Fix dist in Release

* Thu Dec 9 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.0.4-1.2.2.2
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew, add BR maven-deploy-plugin
- Add the line to find and remove any binaries
- change BR  maven-release to  maven-release-plugin
- add BR codehaus-stax11-api
- disable "site" document generation

* Wed Jun 30 2010 Permaine Cheung <pcheung@redhat.com> 0:2.0.4-1.2.2.1
- Replace wsdl4j by wsdl4j16 for RHEL 5

* Mon Jun 28 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.0.4-1.2.2
- Remove the listings of Patch0: %{name}-pom_xml.patch and Patch1: %{name}-site_xml.patch

* Mon Jun 28 2010 Yiqiao Wang <yiwang@redhat.com> 0:2.0.4-1.2.1
- Rebuild for EAP 5.1

* Wed Dec 09 2009 Martha Benitez <mbenitez@redhat.com> 0:2.0.4-1.2
- Fix repolib location and depmap fragment
- Change component id and artifact id from ws-commons-neethi to neethi in component-info.xml
- Add pom.xml to repolib
- Add sources.jar to main package and repolib

* Thu Jul 30 2009 Martha Benitez <mbenitez@redhat.com> 0:2.0.4-1.1
- Change jpackage-utils >= 0:1.7.5 to jpackage-utils >= 0:1.7.3
- Change (B)R wstx32 to wstx
- Comment mojo-maven2-plugin-jdepend
- Add repolib

* Tue Jul 28 2009 David Walluck <dwalluck@redhat.com> 0:2.0.4-1
- 2.0.4

* Mon Mar 23 2009 Ralph Apel <r.apel at r-apel.de> 0:2.0.1-4.jpp5
- (B)R wstx32 because wstx is frozen to 3.1.1 in JPP-5

* Mon Feb 09 2009 Ralph Apel <r.apel at r-apel.de> 0:2.0.1-3.jpp5
- Rebuild with current best practices

* Wed Jul 11 2007 Ralph Apel <r.apel at r-apel.de> 0:2.0.1-2jpp
- Remove false Provides/Obsoletes ws-commons-policy

* Wed May 30 2007 Ralph Apel <r.apel at r-apel.de> 0:2.0.1-1jpp
- Upgrade to 2.0.1
- Build with maven2 by default
- Make Vendor, Distribution based on macro
- Add gcj_support option

* Fri May 19 2006 Deepak Bhole <dbhole@redhat.com> 0:1.0-1jpp
- Initial build
